Attribute VB_Name = "modOffsetVolts"
Option Explicit
'1-20-14 new function to copy CHoffset.ini to windows folder the first time that app is run
Public Function copyCHoffsetsToWinFolder()
    Dim strFolder As String
    Dim lngResult As Long
    On Error GoTo EXIT_ERR
    strFolder = String(MAX_PATH, 0)
    lngResult = GetWindowsDirectory(strFolder, MAX_PATH)
    If lngResult <> 0 Then
        Shell ("CopyIni.bat")
        copyCHoffsetsToWinFolder = True
    Else
        copyCHoffsetsToWinFolder = False
    End If
    Exit Function
    
EXIT_ERR:
    MsgBox vbCrLf & "Could not copy CHOffset.ini to Windows folder." _
        & vbCrLf & vbCrLf & "CHOffset.ini should be in current application folder but doesn't seem to be.  " _
        & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
    copyCHoffsetsToWinFolder = False
End Function

Public Function CheckIniExist_CHoffsets() As Boolean
    If Dir(Environ$("windir") & "\CHOffset.ini") <> "" Then
      'MsgBox "File CHOffset exists"
    Else
      'MsgBox "File CHOffset does not exist"
        Dim copySuccess As Boolean
        If copyCHoffsetsToWinFolder() = False Then
            MsgBox vbCrLf & "Could not copy CHOffset.ini to Windows folder." _
            & vbCrLf & vbCrLf & "CHOffset.ini should be in current application folder." _
            & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
            CheckIniExist_CHoffsets = False: Exit Function
        End If
        
        'need to do this here because reading from the ini file that we just made
        ' won't work the first pass through - until the function that calls this
        ' function returns and then is recalled - so it's easier just to do this
        Dim bIndex As Byte: Dim bIndex2 As Byte
        For bIndex = 0 To 5
            For bIndex2 = 0 To 15
                dblOffsetVoltages(bIndex, bIndex2) = 0#
            Next bIndex2
        Next bIndex
        bUseOffsetVoltages = 0 'nothing to use because they are all zero
    End If
      'MsgBox "File CHOffset created, exiting true"
    CheckIniExist_CHoffsets = True
    
    'there was code (before exiting function) removed below that existed before this date 2-25-14
End Function
Public Function ReadIniFileSpecs_CHoffsets() As Boolean
    Dim lRetVal_LOCAL As Long
    Dim bIndex As Byte
    Dim strIniString As String: strIniString = String(32, vbNullChar)
    Dim subChStr As String
    Dim bMainChan As Byte
    bMainChan = frmGraph.comboMainChan.Text
    If fIsEMFapp Then
        bMainChan = bMainChan + 1
    End If
    
    
    Dim dblVoltsTemp As Double
    Dim fAllOffsetsAreZero_TOM As Boolean: fAllOffsetsAreZero_TOM = True
    If CheckIniExist_CHoffsets = False Then
        '2-25-14 GoTo EXIT_ERR
        Exit Function
    End If
    On Error GoTo EXIT_ERR
    
'TIM NOTE: the code below won't exectute if the INI files didn't already exist because even though
' they have just been created if they didn't exist, they can't be read (for some reason) until this
' function is exited and then reintered. The way I discoverd this is, if the offset file doesn't exist
' the M201_grf.ini will likely also not exist, yet if the offset file is created here, the tries to
' read it below will generate an error, yet after returning, the reading of the M201_grf.ini won't
' generate an error but would if both files weren't created here. On this date 2-25-14 I fixed all the
' problems for checking for the existance of the INI files when the form first loads. However, this
' must be run with adminstrator rights in most newer windows in order for the files to be created.
    
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN0", subChStr, "", strIniString, 9, "CHoffset.ini")
        dblOffsetVoltages(0, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(0, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN1", subChStr, "", strIniString, 9, "CHoffset.ini")
        dblOffsetVoltages(1, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(1, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN2", subChStr, "", strIniString, 9, "CHoffset.ini")
        dblOffsetVoltages(2, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(2, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN3", subChStr, "", strIniString, 9, "CHoffset.ini")
        dblOffsetVoltages(3, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(3, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN4", subChStr, "", strIniString, 9, "CHoffset.ini")
        dblOffsetVoltages(4, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(4, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN5", subChStr, "", strIniString, 9, "CHoffset.ini")
        dblOffsetVoltages(5, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(5, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    
    Dim fRetVal As Boolean
    
    'MsgBox "3"
    
    'TIM NOTE: Changed to following on 3-29-04 when Tom said that if all entries in the offset file
    ' are zero, then uncheck the use offset checkbox
    If fAllOffsetsAreZero_TOM = True Then
        '9-24-13 frmGraphTextVolts.txtUsingOffsetVoltage.Text = "NOT using offset voltage"
'        bConfigChanges(CONFIG_MISC_USE_OFFSET_VOLTS) = 0
        bUseOffsetVoltages = 0
    Else
        '9-24-13 frmGraphTextVolts.txtUsingOffsetVoltage.Text = "USING offset voltage"
        bUseOffsetVoltages = True
    End If
    
    ReadIniFileSpecs_CHoffsets = True
    GoTo EXIT1
     
EXIT_ERR:
    
    '2-25-14 MsgBox vbCrLf & "Failed to read  CHOffset.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf
    '2-25-14 ReadIniFileSpecs_CHoffsets = False
    
    '2-25-14 note that even if we create the offset ini file above because it didn't exist, there will still
    ' be an error generated (bringing us here) if we try to read it before returning from this function.
    'But since adding the functionality to check for the ini files when the main form loads, it should work
    ' everytime and we should never end up here.
    Err.Clear '2-25-14
    ReadIniFileSpecs_CHoffsets = True '2-25-14
    
EXIT1:
    On Error GoTo 0
End Function

'Public Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" _
    (ByVal lpszSection As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
Public Function WriteIniFileSpecs_CHoffsets_CurChan() As Boolean
    Dim lRetVal_LOCAL As Long
    Dim bIndex As Byte
    Dim strIniString As String: strIniString = String(32, vbNullChar)
    Dim subChStr As String
    Dim bMainChan As Byte
    bMainChan = frmGraph.comboMainChan.Text
    If fIsEMFapp Then bMainChan = bMainChan - 1
    
    Dim dblVoltsTemp As Double
    If CheckIniExist_CHoffsets = False Then GoTo EXIT_ERR

    On Error GoTo EXIT_ERR
    Dim strChOffsetVoltage As String
    
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(0, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN0", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    
'    If fIsEMFapp Then
'        WriteIniFileSpecs_CHoffsets_CurChan = True
'        Exit Function
'    End If
    
    
'10-3-14 commented all of following
'    For bIndex = 0 To 15
'        strChOffsetVoltage = Format$(str(dblOffsetVoltages(1, bIndex)), "##.000000")
'        subChStr = bIndex
'        lRetVal_LOCAL = WritePrivateProfileString("CHAN1", subChStr, strChOffsetVoltage, "CHoffset.ini")
'    Next bIndex
'    For bIndex = 0 To 15
'        strChOffsetVoltage = Format$(str(dblOffsetVoltages(2, bIndex)), "##.000000")
'        subChStr = bIndex
'        lRetVal_LOCAL = WritePrivateProfileString("CHAN2", subChStr, strChOffsetVoltage, "CHoffset.ini")
'    Next bIndex
'    For bIndex = 0 To 15
'        strChOffsetVoltage = Format$(str(dblOffsetVoltages(3, bIndex)), "##.000000")
'        subChStr = bIndex
'        lRetVal_LOCAL = WritePrivateProfileString("CHAN3", subChStr, strChOffsetVoltage, "CHoffset.ini")
'    Next bIndex
'    For bIndex = 0 To 15
'        strChOffsetVoltage = Format$(str(dblOffsetVoltages(4, bIndex)), "##.000000")
'        subChStr = bIndex
'        lRetVal_LOCAL = WritePrivateProfileString("CHAN4", subChStr, strChOffsetVoltage, "CHoffset.ini")
'    Next bIndex
'    For bIndex = 0 To 15
'        strChOffsetVoltage = Format$(str(dblOffsetVoltages(5, bIndex)), "##.000000")
'        subChStr = bIndex
'        lRetVal_LOCAL = WritePrivateProfileString("CHAN5", subChStr, strChOffsetVoltage, "CHoffset.ini")
'    Next bIndex
    
    
'10-3-14 added all of following
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(0, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN0", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(1, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN1", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(2, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN2", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(3, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN3", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(4, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN4", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(5, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN5", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    
    
    
    
    
    
    
    
    
    
    WriteIniFileSpecs_CHoffsets_CurChan = True
    GoTo EXIT1
     
EXIT_ERR:
    MsgBox vbCrLf & "Failed to write  CHOffset.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf
    WriteIniFileSpecs_CHoffsets_CurChan = False
EXIT1:
    On Error GoTo 0
End Function
Public Function WriteIniFileSpecs_CHoffsets_SetAllZero_TOM() As Boolean
'TIM NOTE: Tom wanted this 3-29-04
'He said he wanted to zero every channel in the entire offset file
' whenever the zero offset button was pressed, and then afterwards
' to uncheck the "use offset" checkbox

    Dim lRetVal_LOCAL As Long
    Dim bIndex, bIndex2 As Byte
    Dim strIniString As String: strIniString = String(32, vbNullChar)
    Dim subChStr As String
    Dim bMainChan As Byte
    bMainChan = frmGraph.comboMainChan.Text
    If fIsEMFapp Then bMainChan = bMainChan - 1
    Dim dblVoltsTemp As Double
    If CheckIniExist_CHoffsets = False Then GoTo EXIT_ERR

    On Error GoTo EXIT_ERR
    Dim strChOffsetVoltage As String
    
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN0", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN1", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN2", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN3", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN4", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN5", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    
    For bIndex = 0 To 5
        For bIndex2 = 0 To 15
            dblOffsetVoltages(bIndex, bIndex2) = 0#
        Next bIndex2
    Next bIndex
    
    'TIM NOTE: The following is to support Tom's request to set all offsets
    '  (main and sub chans) to zero if user presses the "zero offset" button
    
    '9-24-13 If frmGraphTextVolts.txtUsingOffsetVoltage.Text = "USING offset voltage" Then
    '9-24-13     frmGraphTextVolts.txtUsingOffsetVoltage.Text = "NOT using offset voltage"
        'bConfigChanges(CONFIG_MISC_USE_OFFSET_VOLTS) = 0
    '9-24-13     bUseOffsetVoltages = 0
    '9-24-13 End If
    
    WriteIniFileSpecs_CHoffsets_SetAllZero_TOM = True
    GoTo EXIT1
     
EXIT_ERR:
    MsgBox vbCrLf & "Failed to write  CHOffset.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf
    WriteIniFileSpecs_CHoffsets_SetAllZero_TOM = False
EXIT1:
    On Error GoTo 0
End Function


